#define	ENABLE_NLS
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <glade/glade.h>
#include <glade/glade-xml.h>

#include "ucs-framework.h"
#include "ucs-cell-renderer-text.h"
#include "ucs-utils.h"

#define CLR_DISABLE "#ffffeb"
#define CLR_ACTIVE  "#adc4ff"
#define CLR_NORMAL  "#eaf8ff"
#define CLR_REQUIRE "#a8b6db"
#define CLR_TEXT    "#000000"
/* TODO
 * UI file name, numboer of entries, module name setting
 */
#define	UI_XML_FILE	"./bm104.glade"
#define ENTRIES     19
#define BTTNS       5
#define TBTTNS      5
#define BRW         1
#define SEARCH      3
#define PROG_NAME   "bm104"
#define PANED_SIZE  500
#define MAX_SIZE    1024
//#define HAVE_SUB_BROWSE 
static GtkWidget    *sp_window      = NULL;
static GladeXML     *sp_main_xml    = NULL;
static Tbl          *sp_data        = NULL;
/*
 * Framework 사용 structure
 */
static FrameEntry   st_entry[ENTRIES];
static FrameSearch  st_search[SEARCH];
static FrameBttn    st_bttns[BTTNS];
static FrameTbBttn  st_tbttns[TBTTNS];
static FrameBrowse  st_brw;
static FramePaned   st_paned;
static UserPerm     st_user_perm;

static gboolean     sl_update = FALSE;
static gboolean     sl_insert = FALSE;

/*
 * Action control 함수군
 */
static void edit_enable()
{
    int i;

    for( i = 0; i < ENTRIES; i++ )
    {
        if( !st_entry[i].editable )
        {
            gtk_widget_set_sensitive( st_entry[i].widget, TRUE );
        }
    }

    for( i = 0; i< BTTNS; i++ )
    {
        gtk_widget_set_sensitive( st_bttns[i].widget, st_bttns[i].editable );
    }
#ifdef TBTTNS
    for( i = 0; i < TBTTNS; i++ )
    {
        gtk_widget_set_sensitive( st_tbttns[i].widget, st_tbttns[i].editable );
    }
#endif
    gtk_widget_set_sensitive( st_brw.widget, FALSE );
}
static void edit_disable()
{
    int i;

    for( i = 0; i < ENTRIES; i++ )
    {
        gtk_widget_set_sensitive( st_entry[i].widget, FALSE );
    }

    for( i = 0; i < BTTNS; i++ )
    {
        gtk_widget_set_sensitive( st_bttns[i].widget, !st_bttns[i].editable );
    }
#ifdef TBTTNS
    for( i = 0; i < TBTTNS; i++ )
    {
        gtk_widget_set_sensitive( st_tbttns[i].widget, !st_tbttns[i].editable );
    }
#endif
    gtk_widget_set_sensitive( st_brw.widget, TRUE );
}
#ifdef SEARCH
static void search_disable()
{
    int i;
    for ( i = 0; i <  SEARCH; i++ )
    {
        gtk_widget_set_sensitive( st_search[i].widget, FALSE );
    }
}
static void search_enable()
{
    int i;
    for( i = 0; i < SEARCH; i++ )
    {
        gtk_widget_set_sensitive( st_search[i].widget, TRUE );
    }
}
#endif

static void blank()
{
    int i;

    for( i = 0; i < ENTRIES; i++ )
    {
        gtk_entry_set_text( GTK_ENTRY( st_entry[i].widget ), "" );
    }
    /* TODO
     * 추가시 기본적으로 셋팅될 값을 정해준다.
     * 특별히 형태를 가지거나 날자값(오늘날짜)등을 가지는 것들의 셋팅을 한다.
     */

}
/*
 * Browse 관련 함수군
 */

static void browse_expand( gboolean expand )
{
    GtkTreeViewColumn *column;
    int i;

    for( i = 4; i < 6; i++ )
    {
        column = gtk_tree_view_get_column( GTK_TREE_VIEW( st_brw.widget ), i );
        gtk_tree_view_column_set_visible( column, !expand );
    }
}
static void add_columns( GtkWidget *p_treeview,const char *header, int COL_NUM )
{
    GtkCellRenderer *p_renderer;
    GtkTreeViewColumn *p_col;

    p_col = gtk_tree_view_column_new();
    p_renderer = ucs_cell_renderer_text_new();
    p_col = gtk_tree_view_column_new_with_attributes( header, p_renderer, "markup", COL_NUM, NULL );
    gtk_tree_view_append_column( GTK_TREE_VIEW( p_treeview ), p_col );
}
static void define_browse( Array header )
{
    GtkTreeSelection *p_selection;
    int i;

    st_brw.widget = glade_xml_get_widget( sp_main_xml, "brw" );

    gtk_tree_view_set_rules_hint( GTK_TREE_VIEW( st_brw.widget ), TRUE );
    gtk_tree_selection_set_mode( gtk_tree_view_get_selection( GTK_TREE_VIEW( st_brw.widget ) ), GTK_SELECTION_SINGLE );
    st_brw.model = GTK_TREE_MODEL( st_brw.store );
    gtk_tree_view_set_model( GTK_TREE_VIEW( st_brw.widget ), st_brw.model );

    for( i = 0; i < header.nCnt; i++ )
    {
        add_columns( st_brw.widget, header.cdata[i], i+1 );
    }

    p_selection = gtk_tree_view_get_selection( GTK_TREE_VIEW( st_brw.widget ) );
    g_signal_connect( G_OBJECT( p_selection ), "changed", G_CALLBACK( define_browse_changed ), NULL );
}

static void define_browse_changed( GtkTreeSelection *selection, gpointer data )
{
    GValue  p_value = {0,};
    int     row_idx;

    gtk_tree_selection_get_selected( selection, NULL, &st_brw.iter );
    gtk_tree_model_get_value( GTK_TREE_MODEL( st_brw.model ), &st_brw.iter, 0, &p_value );

    row_idx = g_value_get_int( &p_value );
    show_data_by_num( row_idx );
}
#ifdef PANED_SIZE
gboolean define_paned_move( GtkWidget *widget, GdkEventButton *event, gpointer user_data )
{
    if ( st_paned.paned )
    {
        st_paned.paned = 0;
        gtk_paned_set_position( GTK_PANED( widget ), PANED_SIZE);
        browse_expand( TRUE );
    }
    else
    {
        st_paned.paned = 1;
        gtk_paned_set_position( GTK_PANED( widget ), MAX_SIZE);
        browse_expand( FALSE );
    }


    return (TRUE);
}
#endif

// 입력 버튼 클릭시 호출될 넘.. 절대 삽입이 아니라, 추가다.
static gboolean append( GtkWidget *widget, gpointer user_data )
{
   blank();
   sl_insert = TRUE;
   sl_update = FALSE;

   if ( st_paned.paned )
   {
       define_paned_move( GTK_WIDGET( st_paned.widget ), NULL, NULL );
   }
   edit_enable();
   gtk_widget_grab_focus( st_entry[0].widget );
   return (TRUE);
}

static gboolean modify( GtkWidget *widget, gpointer user_data )
{
    if( sp_data->nCnt == 0 )
    {
        msg_alert( "수정할 자료가 없습니다." );
        return ( FALSE );
    }
    sl_insert = FALSE;

    sl_update = FALSE;
   if ( st_paned.paned )
   {
       define_paned_move( GTK_WIDGET( st_paned.widget ), NULL, NULL );
   }
    edit_enable();
    gtk_widget_grab_focus( st_entry[0].widget );
    return (TRUE);
}
static gboolean delete( GtkWidget *widget, gpointer user_data )
{
    if ( sp_data->nCnt == 0 )
    {
        msg_alert( "삭제할 자료가 없습니다." );
        return ( FALSE );
    }

    if ( msg_yes_no( "삭제 하시겠습니까?" ) )
    {
        if ( check_user_perm( 'D' ) )
        {
            printf("%d == %d \n", GTK_TREE_STORE( st_brw.model )->stamp, st_brw.iter.stamp );
            gtk_tree_store_remove( GTK_TREE_STORE( st_brw.store ), &st_brw.iter ); // 리스트에선 제거했음
            // 실제 삭제 루틴 - DB 처리 문제, sp_data에서의 삭제 문제등
            // 알아서 작성할것..
        }
        else
        {
            msg_alert( "삭제 권한이 없습니다." );
        }
    }
    return (TRUE);
}

static gboolean find( int action )
{
    if ( check_user_perm( 'R' ) )
    {
        // 실제 검색 루틴
#ifdef SEARCH
        search_enable();
        gtk_widget_grab_focus( st_search[0].widget );
#endif
    }

    return (TRUE);
}

static gboolean is_save( GtkWidget *widget, gpointer user_data )
{
    int i;
    int row_idx;
    GValue p_value = {0,};
    if( sp_data->nCnt == 0 )
    {
        row_idx = -1;
    }
    else
    {
        gtk_tree_model_get_value( GTK_TREE_MODEL( st_brw.model ), &st_brw.iter, 0, &p_value );
        row_idx = g_value_get_int( &p_value );
    }

    if ( sl_update ) // 수정된게 있다면
    {
        if (msg_yes_no( "자료를 저장하시겠습니까?" ))
        {
            if( sl_insert ) // 추가한것이라면
            {
                if ( check_user_perm( 'C' ) )
                {
                    Array arr;
                    arr = ainit( arr );
                    gtk_tree_store_append(  st_brw.store, &st_brw.iter, NULL );
                    gtk_tree_store_set( st_brw.store, &st_brw.iter, 0, sp_data->nCnt, -1 );
                    row_idx = sp_data->nCnt;
                    for( i = 0; i < ENTRIES; i++ )
                    {
                        arr = aadd( arr, gtk_entry_get_text( GTK_ENTRY( st_entry[i].widget ) ) ? gtk_entry_get_text( GTK_ENTRY( st_entry[i].widget ) ) : "" );
                        if( st_entry[i].is_brw )
                        {
                            gtk_tree_store_set( st_brw.store, &st_brw.iter, st_entry[i].brw_order, arr.cdata[i], -1);
                        }
                    }
                    sp_data = tbladd( sp_data, arr );
                    // 실제 insert 루틴 DB에 넣는부분
                }
            }
            else // 수정이라면
            {
                if ( check_user_perm( 'U' ) )
                {
                    for( i = 0; i < ENTRIES; i++ )
                    {
                        gchar *tmp = g_strdup( gtk_entry_get_text( GTK_ENTRY( st_entry[i].widget ) ) );
                        if( strcmp( sp_data->array[row_idx].cdata[i], tmp )  != 0 )
                        {
                            sp_data->array[row_idx].cdata[i] = strdup( tmp );
                            if ( st_entry[i].is_brw )
                            {
                                gtk_tree_store_set( st_brw.store, &st_brw.iter, st_entry[i].brw_order, tmp, -1 );
                            }
                        }
                        g_free( tmp );
                    }
                    // 실제 update 루틴 DB에 넣는부분
                }
            }
            brw_refresh();
        }
        else // 저장하지 않는다면
        {
            show_data_by_num( row_idx );
        }
    }
    edit_disable();

    gtk_widget_grab_focus( st_brw.widget );
    show_data_by_num( row_idx );
    return (TRUE);
}

/*
 * pattern control 함수군
 */
static void brw_refresh()
{
}

static void entry_refresh( GtkEntry *entry, gchar *text )
{
    gtk_entry_set_text( entry, text );
}

static void show_data_by_num( int row_idx )
{
    int  i;

    if ( row_idx <= sp_data->nCnt && row_idx >= 0 )
    {
        for(i = 0; i < ENTRIES; i++ )
        {
            entry_refresh( GTK_ENTRY( st_entry[i].widget ), sp_data->array[row_idx].cdata[i] );
        }
    }
    else
    {
        blank();
    }
}

static gboolean row_change( int action )
{
    switch (action )
    {
        case 1:
            printf("처음\n");
            break;
        case 2:
            printf("이전\n");
            break;
        case 3:
            printf("다음\n");
            break;
        case 4:
            printf("끝\n");
            break;
    }

    return (TRUE);
}

/*
 * Search entry box 관련 함수군
 */
static gboolean define_search_got_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data )
{
    GdkColor active_color;
    gdk_color_parse(CLR_ACTIVE,&active_color);
    gtk_widget_modify_base( widget, GTK_STATE_NORMAL, &active_color );
    return (FALSE);
}
static gboolean define_search_lost_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data)
{
    GdkColor normal_color;
    gdk_color_parse( CLR_NORMAL,  &normal_color );
    gtk_widget_modify_base( widget, GTK_STATE_NORMAL, &normal_color );
    return (FALSE);
}
static void define_search( )
{
    int i;
    GdkColor normal_color,disable_color,require_color,text_color;

    gdk_color_parse( CLR_NORMAL,  &normal_color );
    gdk_color_parse( CLR_DISABLE, &disable_color );
    gdk_color_parse( CLR_REQUIRE, &require_color );
    gdk_color_parse( CLR_TEXT, &text_color );
    for( i = 0; i < SEARCH; i++ )
    {
        /*
         * 각 엔트리들의 속성에 맞쳐서 초기화를 시킨다
         */
        gtk_widget_modify_base( st_search[i].widget, GTK_STATE_NORMAL, &normal_color  );
        gtk_widget_modify_base( st_search[i].widget, GTK_STATE_INSENSITIVE, &disable_color );
        gtk_widget_modify_text( st_search[i].widget, GTK_STATE_INSENSITIVE, &text_color );
    }
}
static gboolean define_search_key_press(GtkWidget *widget, GdkEventKey *event, gpointer *user_data)
{
    gint i = (int)user_data;

    if( event->keyval == GDK_Up || event->keyval == GDK_KP_Up )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_search[i].p_p_search->widget ) );
        return ( TRUE );
    }
    if( event->keyval == GDK_Down || event->keyval == GDK_KP_Down )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_search[i].p_n_search->widget ) );
        return ( TRUE );
    }
    if ( event->keyval == GDK_Page_Up || event->keyval == GDK_KP_Page_Up )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_search[0].widget ) );
    }
    if ( event->keyval == GDK_Page_Down || event->keyval == GDK_KP_Page_Down )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_search[SEARCH - 1].widget ) );
    }

    // 입력 control attribute 관련 체크 루틴
    if( event->keyval == GDK_Return ) // 최종적 입력후 엔터를 입력했을때
    {
        gchar *p_txt;
        gboolean l_check;
        p_txt = g_strdup( gtk_entry_get_text( GTK_ENTRY( widget ) ) );

        gtk_im_context_focus_out( GTK_ENTRY( st_search[i].widget )->im_context );
        gtk_widget_grab_focus( GTK_WIDGET( st_search[i].p_n_search->widget ) );

        g_free(p_txt);
        return ( l_check );
    }

    return ( FALSE );
}
/*
 * Input entry관련 함수군
 */
static gboolean define_entry_got_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data )
{
    GdkColor active_color;
    int i = (int) user_data;
    if( st_entry[i].need_post )
    {
        st_entry[i].post_func( widget, i );
    }
    gdk_color_parse(CLR_ACTIVE,&active_color);

    gtk_widget_modify_base( widget, GTK_STATE_NORMAL, &active_color );

    return (FALSE);
}
static gboolean define_entry_lost_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data)
{
    GdkColor normal_color;
    int i = (int) user_data;

    if( (st_entry[i].require ) )
    {
        gdk_color_parse( CLR_REQUIRE, &normal_color );
    }
    else
    {
        gdk_color_parse( CLR_NORMAL,  &normal_color );
    }

    gtk_widget_modify_base( widget, GTK_STATE_NORMAL, &normal_color );

    return (FALSE);
}
static void update_entry( GtkEditable *editable, gpointer user_data )
{
    sl_update = TRUE;
}
static void define_entries( )
{
    int i;
    GdkColor normal_color,disable_color,require_color,text_color;

    /* TODO
     * 세부 속성 설정
     * 화면정의서 보고 속성들 셋팅할것.
        st_entry[i].editable = 0;
        st_entry[i].edittype = 0;
        st_entry[i].val_type = 0;
        st_entry[i].require  = 0;
        st_entry[i].need_post= 0;
        st_entry[i].is_brw   = 0;
     */
    st_entry[ 1-1].require = 1;
    st_entry[ 2-1].require = 1;
    st_entry[ 3-1].require = 1;
    st_entry[ 1-1].is_brw = 1;
    st_entry[ 1-1].brw_order = 1;
    st_entry[ 2-1].is_brw = 1;
    st_entry[ 2-1].brw_order = 2;
    st_entry[ 3-1].is_brw = 1;
    st_entry[ 3-1].brw_order = 3;
    st_entry[19-1].is_brw = 1;
    st_entry[19-1].brw_order = 4;
    st_entry[ 4-1].is_brw = 1;
    st_entry[ 4-1].brw_order = 5;
    st_entry[10-1].is_brw = 1;
    st_entry[10-1].brw_order = 6;

    gdk_color_parse( CLR_NORMAL,  &normal_color );
    gdk_color_parse( CLR_DISABLE, &disable_color );
    gdk_color_parse( CLR_REQUIRE, &require_color );
    gdk_color_parse( CLR_TEXT, &text_color );
    for( i = 0; i < ENTRIES; i++ )
    {
        /*
         * 각 엔트리들의 속성에 맞쳐서 초기화를 시킨다
         */
        gtk_widget_modify_base( st_entry[i].widget, GTK_STATE_NORMAL, &normal_color  );
        gtk_widget_modify_base( st_entry[i].widget, GTK_STATE_INSENSITIVE, &disable_color );
        gtk_widget_modify_text( st_entry[i].widget, GTK_STATE_INSENSITIVE, &text_color );

        if( (st_entry[i].max_length ) )
        {
            gtk_entry_set_max_length( GTK_ENTRY( st_entry[i].widget ), st_entry[i].max_length );
        }
        if( (st_entry[i].require) )
        {
            gtk_widget_modify_base( st_entry[i].widget, GTK_STATE_NORMAL, &require_color );
        }
        if( (st_entry[i].editable) )
        {
            gtk_widget_set_sensitive( st_entry[i].widget, FALSE );
        }
    }
}
static gboolean define_entry_key_press(GtkWidget *widget, GdkEventKey *event, gpointer *user_data)
{
    gint i = (int)user_data;

    if( event->keyval == GDK_Up || event->keyval == GDK_KP_Up )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_entry[i].p_p_entry->widget ) );
        return ( TRUE );
    }
    if( event->keyval == GDK_Down || event->keyval == GDK_KP_Down )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_entry[i].p_n_entry->widget ) );
        return ( TRUE );
    }
    if ( event->keyval == GDK_Page_Up || event->keyval == GDK_KP_Page_Up )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_entry[0].widget ) );
    }
    if ( event->keyval == GDK_Page_Down || event->keyval == GDK_KP_Page_Down )
    {
        gtk_widget_grab_focus( GTK_WIDGET( st_entry[ENTRIES - 1].widget ) );
    }

    // 입력 control attribute 관련 체크 루틴
    if( event->keyval == GDK_Return ) // 최종적 입력후 엔터를 입력했을때
    {
        gchar *p_txt;
        gboolean l_check;
        p_txt = g_strdup( gtk_entry_get_text( GTK_ENTRY( widget ) ) );

        if ( st_entry[i].require && strlen(p_txt) < 1 )
        {
            msg_alert("필수 입력 항목입니다");
            return ( FALSE );
        }
        if ( st_entry[i].validate )
        {
            l_check = st_entry[i].validate_func( widget );
        }
        gtk_im_context_focus_out( GTK_ENTRY( st_entry[i].widget )->im_context );
        gtk_widget_grab_focus( GTK_WIDGET( st_entry[i].p_n_entry->widget ) );

        g_free(p_txt);
        return ( l_check );
    }

    return ( FALSE );
}

/*
 * 버튼 관련 함수군
 */
static gboolean define_buttons_clicked( GtkWidget *widget, gpointer user_data)
{
    int i = (int)user_data;

    if (st_bttns[i].clicked_func != 0)
    {
        st_bttns[i].clicked_func( widget, user_data );
    }
    else
    {
        msg_alert( "행동이 정의되지 않은 버튼입니다.\n전산실로 문의하세요." );
    }

    return (TRUE);
}
static void define_buttons( )
{
    /* TODO : 버튼 클릭시 실행할 함수명들 넣어주기 */
    st_bttns[0].clicked_func = is_save;         // 저장
    st_bttns[1].clicked_func = append;          // 추가
    st_bttns[2].clicked_func = modify;          // 수정
    st_bttns[3].clicked_func = delete;          // 삭제
    st_bttns[4].clicked_func = on_window_exit;  // 종료
}

static void define_tool_buttons()
{
    /* TODO : 버튼 클릭시 실행할 함수명들 넣어주기 */
    st_tbttns[0].clicked_func = find;
    st_tbttns[1].clicked_func = row_change;
    st_tbttns[2].clicked_func = row_change;
    st_tbttns[3].clicked_func = row_change;
    st_tbttns[4].clicked_func = row_change;  
}

static gboolean define_tool_button_clicked( GtkWidget *widget, gpointer user_data )
{
    int i = (int)user_data;

    if (st_tbttns[i].clicked_func != 0)
    {
        st_tbttns[i].clicked_func( i );
    }
    else
    {
        msg_alert( "행동이 정의되지 않은 버튼입니다.\n전산실로 문의하세요." );
    }

    return (TRUE);
}

#ifdef HAVE_MENU
/*
 * 메뉴관련 함수군
 */
static void define_menu()
{
}
#endif

#ifdef HAVE_COMBO
/*
 * 기타위젯 관련 함수군
 */
static void define_combos()
{
}
#endif

/* 
 * Module loading시 초기화 관련 함수 군
 */
static gboolean check_user_perm( char action )
{
    switch ( action )
    {
        case 'C' :
            if ( st_user_perm.create )
            {
                return TRUE;
            }
            break;
        case 'R' :
            if ( st_user_perm.read )
            {
                return TRUE;
            }
            break;
        case 'U' :
            if ( st_user_perm.update )
            {
                return TRUE;
            }
            break;
        case 'D' :
            if ( st_user_perm.delete )
            {
                return TRUE;
            }
            break;
        default :
            return FALSE;
            break;
    }

    msg_alert( "사용 권한이 없는 행동입니다." );
    return FALSE;
}

static void get_user_perm()
{
    // 일단 가지고 오는 외부 루틴을 get_user_info( const char *prog_name, UserPerm *return_var )라고 한다.
#ifdef MDI
    get_user_perm( PROG_NAME, &st_user_perm );
#endif
    st_user_perm.create = 1;
    st_user_perm.read = 1;
    st_user_perm.update = 1;
    st_user_perm.delete = 1;
    st_user_perm.allow = 1;
}

static void load_widget_from_xml()
{
    int i;

    // entry widget load to entry attribute structure
    for( i = 0; i < ENTRIES; i++ )
    {
        st_entry[i].widget = glade_xml_get_widget( sp_main_xml, st_entry[i].name );
        g_signal_connect( G_OBJECT( st_entry[i].widget ), "key_press_event", G_CALLBACK( define_entry_key_press ), (gpointer)i );
        g_signal_connect( G_OBJECT( st_entry[i].widget ), "focus_in_event",  G_CALLBACK( define_entry_got_focus ), (gpointer)i );
        g_signal_connect( G_OBJECT( st_entry[i].widget ), "focus_out_event", G_CALLBACK( define_entry_lost_focus ), (gpointer)i );
        g_signal_connect( G_OBJECT( st_entry[i].widget ), "changed", G_CALLBACK( update_entry ), (gpointer)i );
        if ( i > 0 )
        {
            st_entry[i].p_p_entry = &st_entry[i-1];
            st_entry[i-1].p_n_entry = &st_entry[i];
        }
    }
    st_entry[0].p_p_entry = &st_entry[ENTRIES-1];
    st_entry[ENTRIES-1].p_n_entry = &st_entry[0];

#ifdef BTTNS
    for( i = 0; i < BTTNS; i++ )
    {
        st_bttns[i].widget = glade_xml_get_widget( sp_main_xml, st_bttns[i].name );
        if( st_bttns[i].widget )
        {
            g_signal_connect( G_OBJECT( st_bttns[i].widget ), "clicked", G_CALLBACK( define_buttons_clicked ), (gpointer)i );
        }
        else
        {
            printf("Widget name incorrect!! must check your glade file %s on %s widget\n",UI_XML_FILE, st_tbttns[i].name );
        }
    }
#endif
    st_bttns[ 0].editable = 1;

#ifdef TBTTNS
    for( i = 0; i < TBTTNS; i++ )
    {
        st_tbttns[i].widget = glade_xml_get_widget( sp_main_xml, st_tbttns[i].name );
        if( st_tbttns[i].widget )
        {
            g_signal_connect( G_OBJECT( st_tbttns[i].widget ), "clicked", G_CALLBACK( define_tool_button_clicked ), (gpointer)i );
        }
        else
        {
            printf("Widget name incorrect!! must check your glade file %s on %s widget\n",UI_XML_FILE, st_tbttns[i].name );
        }
    }
#endif

#ifdef SEARCH
    for( i = 0; i < SEARCH; i++ )
    {
        st_search[i].widget = glade_xml_get_widget( sp_main_xml, st_search[i].name );
        if( st_search[i].widget )
        {
            if ( i > 0 )
            {
                st_search[i].p_p_search = &st_search[i-1];
                st_search[i-1].p_n_search = &st_search[i];
            }
            g_signal_connect( G_OBJECT( st_search[i].widget ), "key_press_event", G_CALLBACK( define_search_key_press ), (gpointer)i );
            g_signal_connect( G_OBJECT( st_search[i].widget ), "focus_in_event",  G_CALLBACK( define_search_got_focus ), (gpointer)i );
            g_signal_connect( G_OBJECT( st_search[i].widget ), "focus_out_event", G_CALLBACK( define_search_lost_focus ), (gpointer)i );
            g_signal_connect( G_OBJECT( st_search[i].widget ), "changed", G_CALLBACK( update_entry ), (gpointer)i );
        }
        else
        {
            printf("Widget name incorrect!! mush check your glade fines %s on %s widget\n",UI_XML_FILE, st_search[i].name );
        }
    }
    st_search[0].p_p_search = &st_search[SEARCH-1];
    st_search[SEARCH-1].p_n_search = &st_search[0];
#endif

#ifdef PANED_SIZE
    st_paned.widget = glade_xml_get_widget( sp_main_xml, "paned_main" );
    g_signal_connect( G_OBJECT( st_paned.widget ), "button_press_event", G_CALLBACK( define_paned_move ), NULL );
#endif
}

static void init_widgets()
{
    int i;
    gchar *tmp;

    // Entries
    for( i = 0; i < ENTRIES; i++ )
    {
        tmp = g_strdup_printf("entry%d",i+1);
        st_entry[i].name = (char *)malloc( sizeof(char) * strlen(tmp) + 1 );
        strcpy(st_entry[i].name,tmp);
    }
    // Buttons
#ifdef BTTNS
    for( i = 0; i < BTTNS; i++ )
    {
        tmp = g_strdup_printf("bttn%d",i+1);
        st_bttns[i].name = (char *)malloc( sizeof(char) * strlen(tmp) + 1 );
        strcpy(st_bttns[i].name,tmp);
    }
#endif
#ifdef TBTTNS
    for( i = 0; i < TBTTNS; i++ )
    {
        tmp = g_strdup_printf("toolbttn%d",i+1);
        st_tbttns[i].name = (char *)malloc( sizeof(char) * strlen(tmp) + 1 );
        strcpy(st_tbttns[i].name,tmp);
    }
#endif
#ifdef SEARCH
    for( i = 0; i < SEARCH; i++ )
    {
        tmp = g_strdup_printf("entry_find%d",i+1);
        st_search[i].name = (char *)malloc( sizeof(char) *strlen(tmp) + 1 );
        strcpy( st_search[i].name, tmp );
    }
#endif
    g_free(tmp);
}

static int data_get_from_svr(int query_number, Array attr)
{
    //sp_data = (Tbl *)ucs_comm_with_svr(sp_data, query_number, attr );
    if (sp_data->nCnt == 0)
    {
        // 이넘은 아예 데이타가 없거나, 검색조건이 안맞거나 한거다.. 고로 Browse에 뿌려질게 없다
        // 문제는 이게 아예 없는거냐? 아님 검색조건이 안맞는냐 하는거다.
    }
    else
    {

    }

    return -1;
}

static void load_data()
{
    int i_result;
    int i_qno = 1;
    int i, j;
    Array attr;

    attr = ainit( attr );
    attr = aadd(attr, "" );

    sp_data = tblinit( sp_data );

    i_result = data_get_from_svr( i_qno, attr);
    
    if ( i_result < 0 )
    {
        msg_alert( "서버로 부터 자료를 받는중 에러가 발생했습니다. 잠시후 다시 시도해 주세요" );
    }
    else
    {
        // Tree store에 Data를 넣는다.
        for( i = 0; i < sp_data->nCnt; i++ )
        {
            for( j = 0; j < sp_data->array[i].nCnt; j++ )
            {

            }
        }
    }
}

/* TODO
 * 기본적인 설정부분은 여기가 중심이다
 */
static void init_prog()
{
    
    if( !sp_main_xml )
    {
        sp_main_xml = glade_xml_new( UI_XML_FILE, NULL, NULL );
    }
    /*
     *  window_main  << 이부분을 해당 Module의 window name으로 변경할것
     */
    sp_window = glade_xml_get_widget( sp_main_xml, "window_bm104" );
    if( sp_window )
    {
        g_signal_connect( G_OBJECT( sp_window ), "delete_event", G_CALLBACK( on_window_exit ), NULL );
    }
    else
    {
        printf( "Window widget name fault!! check your UI layout file!\n");
        exit(-1);
    }

    get_user_perm();

    init_widgets();
    load_widget_from_xml();

#ifdef HAVE_MENU
    define_menu();
#endif
#ifdef ENTRIES
    define_entries();
#endif
#ifdef SEARCH
    define_search();
#endif
#ifdef HAVE_COMBO
    define_combos();
#endif
#ifdef BTTNS
    define_buttons( );
#endif
    /* TODO : a_header에 헤더정보 넣고, gtk_tree_store_new에 타입정의하기 */
    st_brw.name = g_strdup( "brw" );
    st_brw.header = ainit( st_brw.header );
    st_brw.header = aadd( st_brw.header, "Vendor" );
    st_brw.header = aadd( st_brw.header, "English Name" );
    st_brw.header = aadd( st_brw.header, "Korean Name" );
    st_brw.header = aadd( st_brw.header, "Used" );
    st_brw.header = aadd( st_brw.header, "Pregident" );
    st_brw.header = aadd( st_brw.header, "Tel" );
    st_brw.num_cols = st_brw.header.nCnt;
    st_brw.is_expand = 1;
    st_brw.expand = 4;
    st_brw.store =  gtk_tree_store_new( st_brw.num_cols + 1, G_TYPE_INT, // 여기는 손대지 말것. G_TYPE_INT는 인덱스로 사용되는 내부용임.
            G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING ); // TODO : 여기 컬럼순서대로 자료형 인수로 넘겨줄것.
    define_browse( st_brw.header );
    browse_expand( TRUE );

    load_data();
    edit_disable();
    search_disable();
    if ( sp_data->nCnt > 0 )
    {
        gtk_tree_model_get_iter_first( GTK_TREE_MODEL( st_brw.model ), &st_brw.iter);
        show_data_by_num( 0 );
    }
#ifdef TBTTNS
    define_tool_buttons( );
#endif
    gtk_widget_grab_focus( st_brw.widget );
}
#ifdef MDI
/* TODO
 * PRG_NAME 셋팅
 */
int do_PRG_NAME( GtkWidget do_widget )
{
    if ( !sp_window  )
    {
        if ( !sp_main_xml )
        {
            init_prog();
        }
        if (!do_widget)
        {
            gtk_window_set_screen (GTK_WINDOW (sp_browse), gtk_widget_get_screen (do_widget));
        }
    }

    if (!GTK_WIDGET_VISIBLE (sp_window))
    {
        gtk_widget_show_all (sp_window);
    }
    else
    {    
        gtk_widget_destroy (sp_window);
        window = NULL;
    }

    return sp_window;
}
#else
int main( int argc, char *argv[] )
{
    gtk_init( &argc, &argv );

    init_prog();

    gtk_main();

    return 0;
}
#endif

/*
 * 공통적으로 사용될 유틸리티 함수군
 */
static gboolean msg_yes_no( const char *msg )
{
    GtkWidget *p_ynbox;
    gint       i_response ;
    
    GtkWidget *parent = sp_window;

    p_ynbox = gtk_message_dialog_new( GTK_WINDOW( parent ), GTK_DIALOG_MODAL , GTK_MESSAGE_QUESTION,  GTK_BUTTONS_YES_NO, msg );
    i_response = gtk_dialog_run( GTK_DIALOG( p_ynbox ) );
    gtk_dialog_response( GTK_DIALOG( p_ynbox ), i_response );
    gtk_widget_destroy( p_ynbox );

    if ( i_response == GTK_RESPONSE_NO )
    {
        return FALSE;
    }
    return TRUE;
}

static gboolean msg_alert( const char *msg )
{
    GtkWidget *p_ynbox;
    gint       i_response ;
    
    GtkWidget *parent = sp_window;

    p_ynbox = gtk_message_dialog_new( GTK_WINDOW( parent ), GTK_DIALOG_MODAL , GTK_MESSAGE_WARNING,  GTK_BUTTONS_CLOSE, msg );
    i_response = gtk_dialog_run( GTK_DIALOG( p_ynbox ) );
    gtk_dialog_response( GTK_DIALOG( p_ynbox ), i_response );
    gtk_widget_destroy( p_ynbox );

    if ( i_response == GTK_RESPONSE_NONE )
    {
        return FALSE;
    }
    return TRUE;
}

static gboolean on_window_exit( GtkObject *object, gpointer user_data )
{
    if ( msg_yes_no( "종료하시겠습니까?" ) )
    {
#ifdef MDI
        gtk_widget_destroy( sp_window );
#else
        gtk_main_quit();
#endif
        return FALSE;
    }
    return TRUE;
}
