#ifndef UCS_FRAMEWORK
#define UCS_FRAMEWORK

#include <gtk/gtk.h>
#include "ucs-utils.h"

typedef struct _ucs_frame_entry
{
    char        *name;
    GtkWidget   *widget;
    int          max_length;
    guint        editable : 1;
    guint        edittype : 1;
    guint        validate : 1;
    guint        require  : 1;
    guint        need_post: 1;
    guint        is_brw   : 1;
    guint        brw_order;
    gboolean    (*validate_func) ( GtkWidget *widget );
    gboolean    (*post_func) ( GtkWidget *widget, int i );
    struct _ucs_frame_entry *p_p_entry;
    struct _ucs_frame_entry *p_n_entry;
} FrameEntry ;

typedef struct _ucs_frame_search
{
    char        *name;
    GtkWidget   *widget;
    struct  _ucs_frame_search *p_p_search;
    struct  _ucs_frame_search *p_n_search;
} FrameSearch ;

typedef struct _ucs_frame_brw
{
    char         *name;
    GtkWidget    *widget;
    GtkTreeModel *model;
    GtkTreeStore *store;
    GtkTreeIter   iter;
    guint         num_cols;
    Array         header;
    guint         is_expand : 1;
    guint         expand;
} FrameBrowse;

typedef struct _ucs_framework_bttn
{
    char        *name;
    GtkWidget   *widget;
    guint        editable : 1;
    gboolean    (*clicked_func) ( GtkWidget *widget, gpointer user_data );
} FrameBttn ;

typedef struct _ucs_framework_tb_bttn
{
    char        *name;
    GtkWidget   *widget;
    guint        editable : 1;
    gboolean    (*clicked_func) ( int action );
} FrameTbBttn ;

typedef struct _ucs_framework_paned
{
    GtkWidget   *widget;
    guint        paned : 1;
} FramePaned ;

typedef struct _user_perm
{
    guint       create : 1;
    guint       read   : 1;
    guint       update : 1;
    guint       delete : 1;
    guint       allow  : 1;
} UserPerm ;

static void edit_enable();
static void edit_disable();
static void blank();
static gboolean append( GtkWidget *widget, gpointer user_data );
static gboolean modify( GtkWidget *widgrt, gpointer user_data );
static gboolean delete( GtkWidget *widget, gpointer user_data );
static gboolean find( int action );
static gboolean is_save( GtkWidget *widget, gpointer user_data );
static void brw_refresh();
static void entry_refresh();
static void show_data_by_num( int row_idx );
static gboolean define_entry_got_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data );
static gboolean define_entry_lost_focus( GtkWidget *widget, GdkEventFocus *event, gpointer user_data);
static void define_entries( );
static gboolean define_entry_key_press(GtkWidget *widget, GdkEventKey *event, gpointer *user_data);
static void add_columns( GtkWidget *p_treeview,const char *header, int COL_NUM );
static void define_browse( Array header );
static void define_browse_changed( GtkTreeSelection *selection, gpointer data );
static gboolean define_buttons_clicked( GtkWidget *widget, gpointer user_data);
static void define_buttons( );
static void define_tool_buttons();
static gboolean define_tool_button_clicked( GtkWidget *widget, gpointer user_data );
static gboolean check_user_perm( char action );
static void get_user_perm();
static void load_widget_from_xml();
static void init_widgets();
static int data_get_from_svr(int query_number, Array attr);
static void load_data();
static void init_prog();
static gboolean msg_yes_no( const char *msg );
static gboolean msg_alert( const char *msg );
static gboolean on_window_exit(  );
#endif
