#ifndef UTIL_H
#define UTIL_H

typedef struct _array
{
	int nCnt;
	char **cdata;
} Array;

typedef struct _tbl
{
	int nCnt;
	Array *array;
} Tbl;

void *mymemcpy(void *s1,const void *s2, size_t n);
void *mymemmove(void *s1, const void *s2, size_t n);
void *mymemset(void *s,const int c, size_t n);
void *mycalloc( size_t nelem, size_t size);
char *mystrdel(char *string, char str);
int   str_find(char *string, char *ch);
char *str_right(char *src,int x);
char *str_left(char *src,int x);
char *str_sub(char *src,int ns,int x);
char *str_up(char *src);
char *str_down(char *src);
char *str_replace(char *string, char *key,const char *value);
char *str_duplicate(char *src,const char *key,int x);
char *str_padr(char *string,int x,const char pad);
char *str_padl(char *string,int x,const char pad);
char *str_rtrim(char *src);
char *str_ltrim(char *src);
char *str_alltrim(char *src);
void  str_qs(char **cdata,int left,int right);
Array ainit(Array array);
Array asort(Array array);
Array aadd(Array array,const char *string);
Array adel(Array array,char *string);
Array aclone(Array dest, Array src);
int   ascan(Array array,char *key);
Tbl  *tblinit(Tbl *tbl);
Tbl  *tbladd(Tbl *tbl,Array array);
Tbl  *tblremove(Tbl *tbl,int index);
#endif
